import { ValidationRule, Validator as V } from 'fastest-validator';

declare module "fn-handler-validator" {

  export interface SchemaObject {
    [propName: Number]: ValidationRule;
  };

  export type SchemaArray = Array<ValidationRule>;

  export type Schema = SchemaArray | SchemaObject;

  export class Validator extends V {
    constructor(props: Schema): Function;
  }

  export default class HandlerValidator extends Validator {
    constructor(fn: Function, schema: Schema): Function;
  }

}
