
const V = require("fastest-validator");
const ValidatorError = require("./error");

module.exports = class Validator extends V {

  constructor(props) {
    super();
    if (!props)
      props = { '0': { type: 'any', optional: true } };

    if (props instanceof Object)
      this.checkObj(props);

    Object.keys(this.messages).forEach(key => {
      this.messages[key] = this.messages[key].replace('The ', 'The argument in position ');
    });

    return new Proxy(
      this.compile({
        $$root: true,
        type: 'object',
        props: { ...props }
      }),
      this.validateHandle.bind(this));
  };

  checkObj(props) {
    const schema = {
      $$root: true,
      type: 'array',
      items: {
        type: 'number', convert: true, integer: true
      }
    };

    const check = this.validate(Object.keys(props), schema);

    if (check.length)
      throw new ValidatorError('The object must have an enumerated key', check);
  }

  validateHandle(fn, thisArg, argArr) {
    const isValid = fn(argArr);
    if (isValid.length)
      throw new ValidatorError('invalid args', isValid);
    return isValid;
  }
};
